#!/usr/bin/env node
// DEBUG CLI npmRoot=../../../plugins dpro dev 
const resolveCwd = require('resolve-cwd');
const chalk = require('chalk');
const debug = require('debug')('dingtalk-cli-pro:bin');
const yosay = require('yosay');
const user = require('../lib/util/user');
const config = require('./config');
const moment = require('moment');

debug('client userinfo %o', user.getGitUserInfo())

debug('client config', config);
const localCLI = resolveCwd.silent(`${config.npmName}/bin/client`);

if (localCLI && localCLI !== __filename) {
  debug(`Using local install of ${config.clientName} cli`);
  require(localCLI);
} else {
  if (config.SYSTEM_COMMAND_LIST.indexOf(config.command) === -1) {
    debug('run system command %s', config.command);
    console.log(yosay(`Hello ${chalk.blue(user.getGitUserInfo().username || 'Guys')}, Welcome to \n${chalk.red(' ' + config.npmName)}\n\n ${chalk.yellow('  ' + moment().format('YYYY-MM-DD hh:mm'))}`))
  }
  
  require('../lib/cli');
}
