const yParser = require('yargs-parser');
const path = require('path');
const lodash = require('lodash');
const pkg = require('../package.json');

const npmRoot = process.env.npmRoot ? process.env.npmRoot : '../../';

let CONSTANT_CONFIG = {
  'env': process.env.npmRoot ? 'dev' : 'prod',
  'dir':  path.dirname(require.resolve('../package')),
  'version': pkg.version,
  'script': process.argv[2],
  'npmRoot': path.resolve(__dirname, npmRoot),
  'npmClient': 'tnpm',
  'argv': yParser(process.argv.slice(2)),
  'clientName': 'dpro',
  'brandName': 'dingtalk',
  'npmName': 'dingtalk-cli-pro',
  'WHITE_LIST': ['@ali', '@alipay'],
  'SYSTEM_PLUGIN_LIST': ['dingtalk-plugin-react', 'dingtalk-plugin-webpack-react', 'dingtalk-plugin-typescript', 'dingtalk-plugin-rollup-ts'],
  'SYSTEM_COMMAND_LIST': ['dev', 'publish', 'build', 'init', 'must', 'test', 'react', 'ts', 'wprt', 'rpts', 'i', 'p', 'd', 'm', 't'],
  'PLUGIN_REGEXP': '^(@ali\\/)?dingtalk-plugin-',
  'UPDATE_CHECK_INTERVAL': 0
}

CONSTANT_CONFIG.command = lodash.get(CONSTANT_CONFIG.argv, '_.[0]');



module.exports = CONSTANT_CONFIG;