
const chalk = require('chalk');
const path = require('path');
const util = require('../util.js');
const lodash = require('lodash');
const spawn = require('../util/spawn-command');
const config = require('../../bin/config');
const question = require('./generator/init');

// 根据DEF构建特定性云构建
module.exports = function(client) {
  client
  .registryCommand('init')
  .alias('i')
  .option('-r, --react', 'React Scaffold(PC OR H5)')
  .option('-t, --typescript', 'Typescript Scaffold')
  .description(chalk.yellow('Init Your App Scaffold'))
  .action(async (cmd) => {
    // update packages
    if (cmd.react || cmd.typescript) {
      if (cmd.react) {
        spawn.spawnCommandSync(config.clientName, ['react'])
      }
  
      if (cmd.typescript) {
        spawn.spawnCommandSync(config.clientName, ['ts'])
      }
    } else {
      this.prompt(question).then(answer => {
        const { scaffold } = answer;
        if (scaffold === 'react') {
          spawn.spawnCommandSync(config.clientName, ['react'])
        }

        if (scaffold === 'typescript') {
          spawn.spawnCommandSync(config.clientName, ['ts'])
        }
      })
    } 
  });
}