
const chalk = require('chalk');
const path = require('path');
const util = require('../util.js');
const lodash = require('lodash');
const spawm = require('../util/spawn-command');


const REGISTRY_MAP = {
  npm: 'https://registry.npmjs.org/',
  tnpm: 'https://registry.npm.alibaba-inc.com'
}

const PUBLISH_CMD = 'def';


// 根据DEF构建特定性云构建
module.exports = function(client) {
  client
  .registryCommand('publish')
  .alias('p')
  .option('-d, --daily', 'Publish App To Daily')
  .option('-o, --online', 'Publish App To Online')
  .description(chalk.yellow('Publish Your App To Daily OR Online'))
  .action(async (cmd) => {
    const abcJson = util.getAbcJson(path.resolve(process.cwd(), './abc.json'));
    const builder = lodash.get(abcJson, 'assets.builder.name');
    if (!cmd.daily && !cmd.online) {
      this.log.error('Please Use Right Publish Command', 'dpro p', '-d', 'or', '-p');
      process.exit(1)
    }

    if (/builder-dingtalk/.test(builder)) {
      const DAILY_DIR = `https://page.wapa.dingtalk.com/app/${abcJson.group}/${abcJson.name}/index.html`
      const ONLINE_DIR = `https://page.dingtalk.com/app/${abcJson.group}/${abcJson.name}/index.html`
      if (cmd.online) {
        spawm.spawnCommandSync(PUBLISH_CMD, ['p', '-o'])
        util.publishDirBoxed(chalk.blue.underline(ONLINE_DIR))
      } else {
        spawm.spawnCommandSync(PUBLISH_CMD, ['p', '-d'])
        util.publishDirBoxed(chalk.blue.underline(DAILY_DIR));
      }
    } else {
      this.log.error('Builder is wrong, Please check abc json', builder, abcJson);
    }
  });
}