var memFs = require("mem-fs");
var editor = require("mem-fs-editor");
var path = require('path');
var fs = require('fs');
var mkdirp = require('make-dir');
var lodash = require('lodash');

var store = memFs.create();
var fsEditor = editor.create(store);

function write(file) {
  var dir = path.dirname(file.path);
  if (!fs.existsSync(dir)) {
    mkdirp.sync(dir);
  }

  fs.writeFileSync(file.path, file.contents, {
    mode: file.stat ? file.stat.mode : null
  });
}

function remove(file) {
  rimraf.sync(file.path);
}


/**
 * @override store add function, support write file
 */
store.add = function(file){
  if (file.state === 'modified') {
    write(file);
  } else if (file.state === 'deleted') {
    remove(file);
  }
};

lodash.extend(fsEditor, {
  fsWrite: write,
  fsRemove: remove
})


module.exports = fsEditor;