const client = require('../lib/core');

describe('client core module test ', () => {
  it('1. get plugins folder and name', () => {
  
    // client.loaderInstalledPlugin();
  })

  it('2. excute dintalk command createGenerator', () => {
    client.createGenerator({
      /**
       * configuring 配置模板目录 和 输出目录
       * @param {string} origin   当前模板目录
       * @param {string} target   输出模板目录
       */
      async configuring() {
        return { origin: './test/plugin-test-template', target: './test/app-test'}
      },

      /**
       * writing 拷贝文件以及处理模板文件
       * @example 
       * this.fs.copy(source, target);
       * this.fs.copyTpl(source, target, TemplateData)
       * 
       * @see https://github.com/SBoudrias/mem-fs-editor
       */
      async writing() {
        client.fs.copy(client.templatePath('/Users/matrix/Documents/dingding/ddt/ding-solution/tools/client-cli/lib/generator/plugin-template/*'), client.destinationPath('src'))
      },

      /**
       * install 安装依赖 yarn, tnpm, npm
       * 
       * @example
       * this.tnpmInstall();
       * this.yarnInstall();
       * this.npmInstall();
       */
      async install() {
        this.tnpmInstall();
      },
      
      /**
       * end 最后操作，运行命令
       * 
       * @example 
       * this.spawnCommand('tnpm', ['run', 'start'])
       */
      async end() {
        this.spawnCommand('tnpm', ['run', 'start']);
        this.log.success('generator finish...');
      }

    })
  });

  
}) 
